%define 	pname php
%define 	pversion 5.0.4
%define 	bversion 100
%define 	rpmrelease iworx

%define 	debug_package %{nil}

%define with_oci8  %{?_with_oci8:1}%{!?_with_oci8:0}
%define with_mssql %{?_with_mssql:1}%{!?_with_mssql:0}
%define with_pfpro %{?_with_pfpro:1}%{!?_with_pfpro:0}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define 	build_rht_90   0
%define		build_cos_3x   0
%define		build_fdr_10   0
%define		build_fdr_20   0
%define		build_fdr_30   0
%define		build_fdr_40   0
%define		build_whb_3x   0
%define		build_rhe_2x   0
%define		build_rhe_3x   0
%define		build_rhe_4x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rht90:   	%{expand: %%define build_rht_90   1}}
%{?_with_cos3x: 	%{expand: %%define build_cos_3x   1}}
%{?_with_fdr10: 	%{expand: %%define build_fdr_10   1}}
%{?_with_fdr20: 	%{expand: %%define build_fdr_20   1}}
%{?_with_fdr30: 	%{expand: %%define build_fdr_30   1}}
%{?_with_fdr40: 	%{expand: %%define build_fdr_40   1}}
%{?_with_whb3x: 	%{expand: %%define build_whb_3x   1}}
%{?_with_rhe2x: 	%{expand: %%define build_rhe_2x   1}}
%{?_with_rhe3x: 	%{expand: %%define build_rhe_3x   1}}
%{?_with_rhe4x: 	%{expand: %%define build_rhe_4x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

# Distro Statements
%if %{build_rht_90}
%define		oscode rht90
%define 	ostype RedHat 9
BuildRequires:  bzip2-devel
BuildRequires:	imap-devel
BuildRequires:	curl-devel >= 7.9
BuildRequires:	db4-devel
BuildRequires:	expat-devel
BuildRequires:	freetype-devel
BuildRequires:  gd-devel >= 1.8.4
BuildRequires:	gdbm-devel
BuildRequires:	gmp-devel
BuildRequires:	aspell-devel >= 0.33.0
BuildRequires:  libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	pam-devel
BuildRequires:  libstdc++-devel
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:  zlib-devel
BuildRequires:	pcre-devel
BuildRequires:	libmcrypt-devel
BuildRequires:  bzip2
BuildRequires:	fileutils
BuildRequires:	perl
BuildRequires:	libtool >= 1.4.3
BuildRequires: 	krb5-devel
BuildRequires:	postgresql-devel
BuildRequires: 	unixODBC
BuildRequires: 	unixODBC-devel
BuildRequires: 	libxslt-devel >= 1.0.18-1
BuildRequires:	libxml2-devel >= 2.4.14-1
BuildRequires: 	cyrus-sasl-devel
BuildRequires:	openldap-devel
BuildRequires:	readline-devel
BuildRequires:	libmhash-devel
BuildRequires:	apr-devel
BuildRequires:	apr-util-devel
Requires:       httpd-mmn = %(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)
Requires:	libtool
Requires:	curl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_cos_3x}
%define		oscode cos3x
%define 	ostype CentOS 3.x
BuildRequires:  bzip2-devel
BuildRequires:	imap-devel
BuildRequires:	curl-devel >= 7.9
BuildRequires:	db4-devel
BuildRequires:	expat-devel
BuildRequires:	freetype-devel
BuildRequires:  gd-devel >= 1.8.4
BuildRequires:	gdbm-devel
BuildRequires:	gmp-devel
BuildRequires:	aspell-devel >= 0.50.0
BuildRequires:  libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	pam-devel
BuildRequires:  libstdc++-devel
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:  zlib-devel
BuildRequires:	pcre-devel
BuildRequires:	libmcrypt-devel
BuildRequires:  bzip2
BuildRequires:	fileutils
BuildRequires:	perl
BuildRequires:	libtool >= 1.4.3
BuildRequires: 	krb5-devel
BuildRequires:	rh-postgresql-devel
BuildRequires: 	unixODBC
BuildRequires: 	unixODBC-devel
BuildRequires: 	libxslt-devel >= 1.0.18-1
BuildRequires:	libxml2-devel >= 2.4.14-1
BuildRequires: 	cyrus-sasl-devel
BuildRequires:	openldap-devel
BuildRequires:	readline-devel
BuildRequires:	libmhash-devel
BuildRequires:	apr-devel
BuildRequires:	apr-util-devel
Requires:       httpd-mmn = %(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)
Requires:	libtool
Requires:	curl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_10}
%define		oscode fdr10
%define 	ostype Fedora Core 1
BuildRequires:	imap-devel
BuildRequires:  bzip2-devel
BuildRequires:	curl-devel >= 7.9
BuildRequires:	db4-devel
BuildRequires:	expat-devel
BuildRequires:	freetype-devel
BuildRequires:  gd-devel >= 1.8.4
BuildRequires:	gdbm-devel
BuildRequires:	gmp-devel
BuildRequires:	aspell-devel >= 0.50.0
BuildRequires:  libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	pam-devel
BuildRequires:  libstdc++-devel
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:  zlib-devel
BuildRequires:	pcre-devel
BuildRequires:	libmcrypt-devel
BuildRequires:  bzip2
BuildRequires:	fileutils
BuildRequires:	perl
BuildRequires:	libtool >= 1.4.3
BuildRequires: 	krb5-devel
BuildRequires:	postgresql-devel
BuildRequires: 	unixODBC-devel
BuildRequires: 	libxslt-devel >= 1.0.18-1
BuildRequires:	libxml2-devel >= 2.4.14-1
BuildRequires: 	cyrus-sasl-devel
BuildRequires:	openldap-devel
BuildRequires:	readline-devel
BuildRequires:	libmhash-devel
BuildRequires:	apr-devel
BuildRequires:	apr-util-devel
Requires:       httpd-mmn = %(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)
Requires:	libtool
Requires:	curl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_20}
%define		oscode fdr20
%define 	ostype Fedora Core 2
BuildRequires:  bzip2-devel
BuildRequires:	curl-devel >= 7.9
BuildRequires:	db4-devel
BuildRequires:	expat-devel
BuildRequires:	freetype-devel
BuildRequires:  gd-devel >= 1.8.4
BuildRequires:	gdbm-devel
BuildRequires:	gmp-devel
BuildRequires:	aspell-devel >= 0.50.0
BuildRequires:  libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	pam-devel
BuildRequires:  libstdc++-devel
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:  zlib-devel
BuildRequires:	pcre-devel
BuildRequires:	libmcrypt-devel
BuildRequires:  bzip2
BuildRequires:	fileutils
BuildRequires:	perl
BuildRequires:	libtool >= 1.4.3
BuildRequires: 	krb5-devel
BuildRequires:	postgresql-devel
BuildRequires: 	unixODBC-devel
BuildRequires: 	libxslt-devel >= 1.0.18-1
BuildRequires:	libxml2-devel >= 2.4.14-1
BuildRequires: 	cyrus-sasl-devel
BuildRequires:	openldap-devel
BuildRequires:	libc-client-devel
BuildRequires:	readline-devel
BuildRequires:	libmhash-devel
BuildRequires:	apr-devel
BuildRequires:	apr-util-devel
Requires:       httpd-mmn = %(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)
Requires:	libtool
Requires:	curl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_30}
%define		oscode fdr30
%define 	ostype Fedora Core 3
BuildRequires:  bzip2-devel
BuildRequires:	curl-devel >= 7.9
BuildRequires:	db4-devel
BuildRequires:	expat-devel
BuildRequires:	freetype-devel
BuildRequires:  gd-devel >= 1.8.4
BuildRequires:	gdbm-devel
BuildRequires:	gmp-devel
BuildRequires:	aspell-devel >= 0.50.0
BuildRequires:  libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	pam-devel
BuildRequires:  libstdc++-devel
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:  zlib-devel
BuildRequires:	pcre-devel
BuildRequires:	libmcrypt-devel
BuildRequires:  bzip2
BuildRequires:	fileutils
BuildRequires:	perl
BuildRequires:	libtool >= 1.4.3
BuildRequires: 	krb5-devel
BuildRequires:	postgresql-devel
BuildRequires: 	unixODBC-devel
BuildRequires: 	libxslt-devel >= 1.0.18-1
BuildRequires:	libxml2-devel >= 2.4.14-1
BuildRequires: 	cyrus-sasl-devel
BuildRequires:	openldap-devel
BuildRequires:	libc-client-devel
BuildRequires:	readline-devel
BuildRequires:	libmhash-devel
BuildRequires:	apr-devel
BuildRequires:	apr-util-devel
BuildRequires:	libidn-devel
Requires:       httpd-mmn = %(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)
Requires:	libtool
Requires:	curl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_40}
%define		oscode fdr40
%define 	ostype Fedora Core 4
BuildRequires:  bzip2-devel
BuildRequires:	curl-devel >= 7.9
BuildRequires:	db4-devel
BuildRequires:	expat-devel
BuildRequires:	freetype-devel
BuildRequires:  gd-devel >= 1.8.4
BuildRequires:	gdbm-devel
BuildRequires:	gmp-devel
BuildRequires:	aspell-devel >= 0.50.0
BuildRequires:  libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	pam-devel
BuildRequires:  libstdc++-devel
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:  zlib-devel
BuildRequires:	pcre-devel
BuildRequires:	libmcrypt-devel
BuildRequires:  bzip2
BuildRequires:	fileutils
BuildRequires:	perl
BuildRequires:	libtool >= 1.4.3
BuildRequires: 	krb5-devel
BuildRequires:	postgresql-devel
BuildRequires: 	unixODBC-devel
BuildRequires: 	libxslt-devel >= 1.0.18-1
BuildRequires:	libxml2-devel >= 2.4.14-1
BuildRequires: 	cyrus-sasl-devel
BuildRequires:	openldap-devel
BuildRequires:	libc-client-devel
BuildRequires:	readline-devel
BuildRequires:	libmhash-devel
BuildRequires:	apr-devel
BuildRequires:	apr-util-devel
Requires:       httpd-mmn = %(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)
Requires:	libtool
Requires:	curl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_whb_3x}
%define		oscode whb3x
%define 	ostype White Box 3.x
BuildRequires:  bzip2-devel
BuildRequires:	imap-devel
BuildRequires:	curl-devel >= 7.9
BuildRequires:	db4-devel
BuildRequires:	expat-devel
BuildRequires:	freetype-devel
BuildRequires:  gd-devel >= 1.8.4
BuildRequires:	gdbm-devel
BuildRequires:	gmp-devel
BuildRequires:	aspell-devel >= 0.50.0
BuildRequires:  libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	pam-devel
BuildRequires:  libstdc++-devel
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:  zlib-devel
BuildRequires:	pcre-devel
BuildRequires:	libmcrypt-devel
BuildRequires:  bzip2
BuildRequires:	fileutils
BuildRequires:	perl
BuildRequires:	libtool >= 1.4.3
BuildRequires: 	krb5-devel
BuildRequires:	rh-postgresql-devel
BuildRequires: 	unixODBC
BuildRequires: 	unixODBC-devel
BuildRequires: 	libxslt-devel >= 1.0.18-1
BuildRequires:	libxml2-devel >= 2.4.14-1
BuildRequires: 	cyrus-sasl-devel
BuildRequires:	openldap-devel
BuildRequires:	readline-devel
BuildRequires:	libmhash-devel
BuildRequires:	apr-devel
BuildRequires:	apr-util-devel
Requires:       httpd-mmn = %(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)
Requires:	libtool
Requires:	curl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_2x}
%define		oscode rhe2x
%define 	ostype RedHat Enterprise 2.x
BuildRequires:  bzip2-devel
BuildRequires:	imap-devel
BuildRequires:	curl-devel >= 7.9
BuildRequires:	db4-devel
BuildRequires:	expat-devel
BuildRequires:	freetype-devel
BuildRequires:  gd-devel >= 1.8.4
BuildRequires:	gdbm-devel
BuildRequires:	gmp-devel
BuildRequires:	aspell-devel >= 0.50.0
BuildRequires:  libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	pam-devel
BuildRequires:  libstdc++-devel
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:  zlib-devel
BuildRequires:	pcre-devel
BuildRequires:	libmcrypt-devel
BuildRequires:  bzip2
BuildRequires:	fileutils
BuildRequires:	perl
BuildRequires:	libtool >= 1.4.3
BuildRequires: 	krb5-devel
BuildRequires:	rh-postgresql-devel
BuildRequires: 	unixODBC
BuildRequires: 	unixODBC-devel
BuildRequires: 	libxslt-devel >= 1.0.18-1
BuildRequires:	libxml2-devel >= 2.4.14-1
BuildRequires: 	cyrus-sasl-devel
BuildRequires:	openldap-devel
BuildRequires:	readline-devel
BuildRequires:	libmhash-devel
BuildRequires:	apr-devel
BuildRequires:	apr-util-devel
Requires:       httpd-mmn = %(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)
Requires:	libtool
Requires:	curl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_3x}
%define		oscode rhe3x
%define 	ostype RedHat Enterprise 3.x
BuildRequires:  bzip2-devel
BuildRequires:	imap-devel
BuildRequires:	curl-devel >= 7.9
BuildRequires:	db4-devel
BuildRequires:	expat-devel
BuildRequires:	freetype-devel
BuildRequires:  gd-devel >= 1.8.4
BuildRequires:	gdbm-devel
BuildRequires:	gmp-devel
BuildRequires:	aspell-devel >= 0.50.0
BuildRequires:  libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	pam-devel
BuildRequires:  libstdc++-devel
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:  zlib-devel
BuildRequires:	pcre-devel
BuildRequires:	libmcrypt-devel
BuildRequires:  bzip2
BuildRequires:	fileutils
BuildRequires:	perl
BuildRequires:	libtool >= 1.4.3
BuildRequires: 	krb5-devel
BuildRequires:	rh-postgresql-devel
BuildRequires: 	unixODBC
BuildRequires: 	unixODBC-devel
BuildRequires: 	libxslt-devel >= 1.0.18-1
BuildRequires:	libxml2-devel >= 2.4.14-1
BuildRequires: 	cyrus-sasl-devel
BuildRequires:	openldap-devel
BuildRequires:	readline-devel
BuildRequires:	libmhash-devel
BuildRequires:	apr-devel
BuildRequires:	apr-util-devel
Requires:       httpd-mmn = %(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)
Requires:	libtool
Requires:	curl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_4x}
%define		oscode rhe4x
%define 	ostype RedHat Enterprise 4.x
BuildRequires:	libgcrypt-devel
BuildRequires:  bzip2-devel
BuildRequires:	libc-client-devel
BuildRequires:	curl-devel >= 7.9
BuildRequires:	db4-devel
BuildRequires:	expat-devel
BuildRequires:	freetype-devel
BuildRequires:  gd-devel >= 1.8.4
BuildRequires:	gdbm-devel
BuildRequires:	gmp-devel
BuildRequires:	aspell-devel >= 0.50.0
BuildRequires:  libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	pam-devel
BuildRequires:  libstdc++-devel
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:  zlib-devel
BuildRequires:	pcre-devel
BuildRequires:	libmcrypt-devel
BuildRequires:  bzip2
BuildRequires:	fileutils
BuildRequires:	perl
BuildRequires:	libtool >= 1.4.3
BuildRequires: 	krb5-devel
BuildRequires:	postgresql-devel
BuildRequires: 	unixODBC
BuildRequires: 	unixODBC-devel
BuildRequires: 	libxslt-devel >= 1.0.18-1
BuildRequires:	libxml2-devel >= 2.4.14-1
BuildRequires: 	cyrus-sasl-devel
BuildRequires:	openldap-devel
BuildRequires:	readline-devel
BuildRequires:	libmhash-devel
BuildRequires:	apr-devel
BuildRequires:	apr-util-devel
Requires:       httpd-mmn = %(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)
Requires:	libtool
Requires:	curl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define 	ostype Unknown Distribution
%define		release %{bversion}.%{rpmrelease}
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	PHP Hypertext Preprocessor
Name:		%{pname}
Version:	%{pversion}
Release:	%{release}
License:	PHP License, version 2.02

Group:		Development/Languages
Source0:	%{name}-%{version}.tar.gz
URL:		http://www.php.net/

Distribution:	InterWorx-HAL
Vendor:         NEXCESS.NET L.L.C
Packager:	Chris Wells <clwells@nexcess.net>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

Requires:       php-pear
Obsoletes:	mod_php, php3, phpfi, php-dbg

Source1:	php.ini
Source2:	php-cli.ini
Source3:	php.conf

%description
PHP is an HTML-embedded scripting language. PHP attempts to make it easy
for developers to write dynamically generated webpages. PHP also offers
built-in database integration for several commercial and non-commercial
database management systems, so writing a database-enabled webpage with
PHP is fairly simple. The most common use of PHP coding is probably as a
replacement for CGI scripts. The mod_php module enables the Apache Web
server to understand and process the embedded PHP language in Web pages.

%package devel
Summary:	Files needed for building PHP extensions
Group:		Development/Libraries
Requires: 	php = %{version}-%{release}

%description devel
The php-devel package contains the files needed for building PHP extensions.
If you need to compile your own PHP extensions, you will need to install
this package.

%package mysql
Summary:	A module for PHP applications that use MySQL
Group:		Development/Languages
Requires: 	php = %{version}-%{release}
Requires:	perl
BuildRequires:	mysql-devel
Requires:	mysql
Provides:	php_database
Obsoletes:	mod_php3-mysql

%description mysql
The php-mysql package contains a dynamic shared object that will add MySQL
database support to PHP. MySQL is an object-relational database management
system. PHP is an HTML-embeddable scripting language. If you need MySQL
support for PHP applications, you will need to install this package and
the php or mod_php package.

%package pgsql
Summary: 	A PostgreSQL database module for PHP.
Group: 		Development/Languages
Requires: 	php = %{version}-%{release}
Provides: 	php_database
Obsoletes: 	mod_php3-pgsql, stronghold-php-pgsql

%description pgsql
The php-pgsql package includes a dynamic shared object (DSO) that can
be compiled in to the Apache Web server to add PostgreSQL database
support to PHP. PostgreSQL is an object-relational database management
system that supports almost all SQL constructs. PHP is an
HTML-embedded scripting language. If you need back-end support for
PostgreSQL, you should install this package in addition to the main
php package.

%package ldap
Summary: 	A module for PHP applications that use LDAP.
Group: 		Development/Languages
Requires: 	php = %{version}-%{release}
Obsoletes: 	mod_php3-ldap, stronghold-php-ldap

%description ldap
The php-ldap package is a dynamic shared object (DSO) for the Apache
Web server that adds Lightweight Directory Access Protocol (LDAP)
support to PHP. LDAP is a set of protocols for accessing directory
services over the Internet. PHP is an HTML-embedded scripting
language. If you need LDAP support for PHP applications, you will
need to install this package in addition to the php package.

%package imap
Summary: 	An Apache module for PHP applications that use IMAP.
Group: 		Development/Languages
Requires: 	php = %{version}-%{release}
Obsoletes: 	mod_php3-imap, stronghold-php-imap

%description imap
The php-imap package contains a dynamic shared object (DSO) for the
Apache Web server. When compiled into Apache, the php-imap module will
add IMAP (Internet Message Access Protocol) support to PHP. IMAP is a
protocol for retrieving and uploading e-mail messages on mail
servers. PHP is an HTML-embedded scripting language. If you need IMAP
support for PHP applications, you will need to install this package
and the php package.

%package xmlrpc
Summary: 	A module for PHP applications which use the XML-RPC protocol
Group: 		Development/Languages
Requires: 	php = %{version}-%{release}

%description xmlrpc
The php-xmlrpc package contains a dynamic shared object that will add
support for the XML-RPC protocol to PHP.

##
# SNMP is goofy on many platforms
##
%package snmp
Summary: 	A module for PHP applications that query SNMP-managed devices.
Group: 		Development/Languages
Requires: 	php = %{version}-%{release}
BuildRequires: 	net-snmp-devel, elfutils-devel

%description snmp
The php-snmp package contains a dynamic shared object that will add
support for querying SNMP devices to PHP.  PHP is an HTML-embeddable
scripting language. If you need SNMP support for PHP applications, you
will need to install this package and the php package.

%package odbc
Group: 		Development/Languages
Requires: 	php = %{version}-%{release}
Summary: 	A module for PHP applications that use ODBC databases.
Provides: 	php_database
Obsoletes: 	stronghold-php-odbc

%description odbc
The php-odbc package contains a dynamic shared object that will add
database support through ODBC to PHP. ODBC is an open specification
which provides a consistent API for developers to use for accessing
data sources (which are often, but not always, databases). PHP is an
HTML-embeddable scripting language. If you need ODBC support for PHP
applications, you will need to install this package and the php
package.

%package pear
Group: 		Development/Languages
Summary: 	PHP Extension and Application Repository Components
Requires: 	php = %{version}-%{release}

%description pear
PEAR is a framework and distribution system for reusable PHP
components.  This package contains a set of PHP components from the
PEAR repository.

%package mbstring
Group: 		Development/Languages
Summary: 	PHP multi-byte char support
Requires: 	php = %{version}-%{release}

%description mbstring
The php-mbstring package contains a dynamic shared object that will add
support for multi-byte string handling to PHP.

%package mcrypt
Group: 		Development/Languages
Summary: 	PHP encryption / decryption support
Requires: 	php = %{version}-%{release}

%description mcrypt
The php-mcrypt package contains a dynamic shared object that will add
support for encryption / decryption to php.

%if %{with_oci8}
%package oci8
Group: 		Development/Languages
Summary: 	PHP Oracle support
Requires: 	php = %{version}-%{release}
Provides: 	php_database

%description oci8
The php-oci8 package contains a dynamic shared object that will add
support for accessing OCI8 databases to PHP.
%endif

%if %{with_pfpro}
%package pfpro
Group: 		Development/Languages
Summary: 	PHP Payflow Pro Support
Requires: 	php = %{version}-%{release}
Provides: 	php_database

%description pfpro
Payflow pro support
%endif

%if %{with_mssql}
%package mssql
Group: 		Development/Languages
Summary: 	PHP MSSQL Support
Requires: 	php = %{version}-%{release}, freetds
Provides: 	php_database
BuildRequires: 	freetds-devel

%description mssql
The mssql package contains a dynamic shared object that will add
support for accessing MSSQL databases to PHP.
%endif

%package mhash
Group: 		Development/Languages
Summary: 	PHP mhash support
Requires: 	php = %{version}-%{release}
BuildRequires: 	libmhash-devel

%description mhash
The php-mhash package is a dynamic shared object (DSO) for the Apache
Web server that adds Mhash support to PHP.

%package ncurses
Group: 		Development/Languages
Summary: 	PHP ncurses support
Requires: 	php = %{version}-%{release}
BuildRequires: 	ncurses-devel

%description ncurses
The php-ncurses package contains a dynamic shared object that will add
support for using the ncurses terminal output interfaces.

#%package tidy
#Group: 		Development/Languages
#Summary: 	PHP tidy
#Requires: 	php = %{version}-%{release}

#%description tidy
#tidy support

%prep

%setup -q

# Use correct libdir.
perl -pi -e 's|%{_prefix}/lib|%{_libdir}|' php.ini-dist

# Remove bogus test; position of read position after fopen(, "a+")
# is not defined by C standard, so don't presume anything.
rm -f ext/standard/tests/file/bug21131.phpt

# Tests that fail.
rm -f ext/pspell/tests/01pspell_basic.phpt \
      ext/standard/tests/file/bug22414.phpt \
      ext/session/tests/019.phpt \
      ext/standard/tests/math/pow.phpt \
      ext/standard/tests/math/round.phpt \
      ext/standard/tests/math/abs.phpt \
      ext/iconv/tests/ob_iconv_handler.phpt

# Source is built twice: once for /usr/bin/php, once for the Apache DSO.
mkdir build-cgi build-apache

# Try detecting newest gcc (some distributions have got more then one compiler)
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with nice colors
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

%build

[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

export EXTENSION_DIR=%{_libdir}/php5

##
## CLWELLS - THE LIBTOOLIZE / BUILDCONF SHIT WAS
## BREAKING THE BUILD APPARENLTY
#libtoolize --force --copy
touch acinclude.m4
#./buildconf --force

export CFLAGS="$RPM_OPT_FLAGS -fomit-frame-pointer -fPIC"

# Shell function to configure and build a PHP tree.
build() {
# bison-1.875-2 seems to produce a broken parser; workaround.
mkdir Zend && cp ../Zend/zend_{language,ini}_{parser,scanner}.[ch] Zend
ln -sf ../configure
./configure                                              \
	--prefix=%{_prefix}                              \
	--bindir=%{_bindir}                              \
	--mandir=%{_mandir}                              \
	--localstatedir=%{_localstatedir}                \
	--libdir=%{_libdir}                              \
	--datadir=%{_datadir}                            \
	--includedir=%{_includedir}                      \
	--sysconfdir=%{_sysconfdir}                      \
	--cache-file=../config.cache                     \
        --with-config-file-path=%{_sysconfdir}           \
        --with-config-file-scan-dir=%{_sysconfdir}/php.d \
        --disable-debug                                  \
        --disable-rpath                                  \
        --with-bz2                                       \
        --with-db4=%{_prefix}                            \
        --with-curl                                      \
        --with-exec-dir=%{_bindir}                       \
        --with-freetype-dir=%{_prefix}                   \
        --with-png-dir=%{_prefix}                        \
        --with-gd                                        \
        --with-gdbm                                      \
        --with-gettext                                   \
        --with-ncurses=shared                            \
        --with-gmp                                       \
        --with-iconv                                     \
        --with-jpeg-dir=%{_prefix}                       \
        --with-openssl                                   \
        --with-png                                       \
        --with-expat-dir=%{_prefix}                      \
	--with-xml					 \
	--with-xsl					 \
        --with-xmlrpc=shared                             \
        --with-readline                                  \
        --with-pcre=%{_prefix}                           \
        --with-zlib                                      \
        --with-layout=GNU                                \
        --with-pear=/usr/share/pear                      \
        --with-imap=shared                               \
        --with-imap-ssl                                  \
        --with-kerberos                                  \
        --with-ldap=shared                               \
	--with-mcrypt=shared                             \
        --with-mhash=shared                              \
        --with-mysql=shared,%{_prefix}                   \
        --with-mysqli                                    \
        --with-unixODBC=shared,%{_prefix}                \
        --with-pgsql=shared                              \
        --with-snmp=shared,%{_prefix}                    \
%if %{with_pfpro}
	--with-pfpro=shared,%{_prefix}/local/verisign/payflowpro/linuxrh9 \
%endif
        --enable-mbstr-enc-trans                         \
        --enable-mbregex                                 \
        --enable-mbstring=shared                         \
        --enable-exif                                    \
        --without-oci8                                   \
        --enable-bcmath                                  \
        --enable-ftp                                     \
	--enable-soap                                    \
        --enable-magic-quotes                            \
        --enable-safe-mode                               \
        --enable-sockets                                 \
        --enable-sysvsem                                 \
        --enable-sysvshm                                 \
        --enable-discard-path                            \
        --enable-track-vars                              \
        --enable-trans-sid                               \
        --enable-yp                                      \
        --enable-wddx                                    \
        --enable-memory-limit                            \
        --enable-bcmath                                  \
        --enable-shmop                                   \
        --enable-calendar                                \
        --enable-dbx                                     \
        --enable-dio                                     \
        --enable-mcal                                    \
        --enable-inline-optimization                     \
        --enable-gd-native-ttf                           \
        --enable-pic                                     \
	--disable-wddx                                   \
        --with-dom=shared,%{_prefix}                     \
        --with-dom-xslt=%{_prefix}                       \
        --with-dom-exslt=%{_prefix}                      \
	$*

#	--with-tidy=shared                               \
#        --enable-ucd-snmp-hack                 \
#	--disable-libxml                                 \


%{__make} %{?_smp_mflags}
}

# Build standalone /usr/bin/php
pushd build-cgi
build --enable-force-cgi-redirect
popd

# Build Apache module
pushd build-apache
build --with-apxs2=%{_sbindir}/apxs
popd

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

# temp fix for php5, it wants the httpd.conf to exist
install -m 755 -d %{buildroot}%{_sysconfdir}/httpd/conf
echo 'LoadModule blah_module blah_module.so'   >  %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf
echo 'LoadModule blah_module2 blah_module2.so' >> %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf
chmod 644 %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf

# Install from CGI tree
pushd build-cgi
%{__make}       \
	install \
	INSTALL_ROOT=%{buildroot}
popd

# Install the Apache module
pushd build-apache
%{__make}            \
	install-sapi \
	INSTALL_ROOT=%{buildroot}
popd

# end temp php5 fix
rm -f %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf*

mkdir -p -m0755 %{buildroot}{%{_sysconfdir}/httpd,%{_libdir}/httpd/modules}

install -m0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/php.ini
install -m0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/php-cli.ini

strip --strip-unneeded -R .comment %{buildroot}%{_bindir}/* || :
strip --strip-debug -R .comment %{buildroot}%{_libdir}/php5/*.so || :
strip --strip-debug -R .comment %{buildroot}%{_libdir}/httpd/modules/*.so || :

# install the DSO
install -m 755 -d %{buildroot}%{_libdir}/httpd/modules
install -m 755 build-apache/libs/libphp5.so %{buildroot}%{_libdir}/httpd/modules

# Apache config fragment
install -m 755 -d %{buildroot}%{_sysconfdir}/httpd/conf.d
install -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/httpd/conf.d

install -m 755 -d %{buildroot}%{_sysconfdir}/php.d
install -m 755 -d %{buildroot}%{_localstatedir}/lib/php
install -m 700 -d %{buildroot}%{_localstatedir}/lib/php/session

# Generate files lists and stub .ini files for each subpackage
for mod in pgsql mysql odbc ldap xmlrpc \
	snmp mbstring mcrypt ncurses imap mhash \
    %{?_with_oci8:oci8} %{?_with_mssql:mssql} %{?_with_pfpro:pfpro}; do
    cat > %{buildroot}%{_sysconfdir}/php.d/${mod}.ini <<EOF
; Enable ${mod} extension module
extension=${mod}.so
EOF
    cat > files.${mod} <<EOF
%attr(755,root,root) %{_libdir}/php5/${mod}.so
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/php.d/${mod}.ini
EOF
done

# Remove PEAR testsuite and other unecessary stuff (if available) here.
rm -rf %{buildroot}%{_datadir}/pear/tests
rm -f  %{buildroot}%{_libdir}/php5/*.a
rm -f  %{buildroot}%{_bindir}/{phptar,pearize}

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_datadir}/pear
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/php.ini
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/php-cli.ini
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/conf.d/php.conf

%attr(0555,root,root) %{_libdir}/httpd/modules/libphp5.so

%attr(0511,root,root) %{_bindir}/php
#%attr(0440,root,man)  %{_mandir}/*/*

%files pear
%defattr(-,root,root)
%{_datadir}/pear
%{_sysconfdir}/pear.conf
%{_bindir}/pear

%files devel
%defattr(-,root,root)
%{_includedir}/php
%{_libdir}/php

%attr(0511,root,root) %{_bindir}/php-config
%attr(0511,root,root) %{_bindir}/phpextdist
%attr(0511,root,root) %{_bindir}/phpize

%if %{with_pfpro}
%files pfpro    -f files.pfpro
%endif
%files pgsql    -f files.pgsql
%files mysql    -f files.mysql
%files odbc     -f files.odbc
%files imap     -f files.imap
%files ldap     -f files.ldap
%files snmp     -f files.snmp
%files xmlrpc   -f files.xmlrpc
%files mbstring -f files.mbstring
%files ncurses  -f files.ncurses
#%files tidy	-f files.tidy
%files mhash    -f files.mhash
%files mcrypt   -f files.mcrypt
                                                                               
%changelog
* Fri Apr 15 2005 Chris Wells <clwells@nexcess.net>
- update for 5.0.3 and added tidy support
* Fri Sep 24 2004 Chris Wells <clwells@nexcess.net>
- update for php 5.0.2
- added disable-libxml for compat (wouldn't build on rh9)
- added disable-wddx for compat (wouldn't build on rh9)
* Tue Jun 28 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS
